#!/usr/bin/perl
# 
# sb - weblog management system
# == scripted by Takuya Otani ========
# == copyright (C) SimpleBoxes 2004 ==
# 
# == Module checker for sb ===========
# == created by Rumurin 2004.06.17 ===
# == modified by Takuya Otani ========

{ # 
	use strict;
	use vars qw($gVersion_ @gRequired @gOptional);
	use lib  qw(. ../ext ./ext);
}
{ # ᥤ롼
	&initialize();
	&mainscript();
}
exit(0);

sub initialize {
	$gVersion_ = '0.02';
	@gRequired = ('LWP::UserAgent','HTTP::Request','XML::Parser::Lite','Jcode',);
	@gOptional = ('Image::Magick','Net::SMTP');
	print 'Content-Type: text/html;charset=EUC-JP',"\n\n";
	print <<'_HTML_HEAD_';
<html>
<head>
	<meta http-equiv="Content-Style-Type" content="text/css" />
	<meta http-equiv="Content-Type" content="text/html; charset=EUC-JP">
	<style type="text/css">
		body { margin: 10px; padding: 0px; font-size: 12px; line-height: 135%; color: #333; background-color: #fff; }
		h1 { font-size: 110%; margin: 0px; border-bottom: 1px dashed #a0a0ff; color: darkred; }
		h2 { font-size: 100%; font-weight: bold; color: darkgreen; margin: 8px 0px 0px 0px; }
		h3 { font-size: 100%; font-weight: bold; color: blue; margin: 8px 0px 0px 0px; }
		.notinstalled { color: red; }
		.installed { color: green; }
	</style>
	<title>⥸塼å for sb</title>
</head>
<body>
<h1>⥸塼å for sb</h1>
_HTML_HEAD_
	return(1);
}
sub mainscript {
	my $flag = 0;
	print '<h2>ɬܥ⥸塼</h2>',"\n",'<ul>',"\n";
	foreach my $lib (@gRequired) {
		my $eval = 'use ' . $lib . ';';
		eval($eval);
		if ($@) {
			print '<li class="notinstalled">',$lib,'ϥ󥹥ȡ뤵Ƥޤ</li>',"\n";
			$flag = 1;
		} else {
			print '<li class="installed">',$lib,'ϥ󥹥ȡ뤵Ƥޤ</li>',"\n";
		}
	}
	print '</ul>',"\n",'<h3>³å</h3>',"\n";
	&check_ua($flag);
	print '<h2>ץ⥸塼</h2>',"\n",'<ul>',"\n";
	foreach my $lib (@gOptional) {
		my $eval = 'use ' . $lib . ';';
		eval($eval);
		if ($@) {
			print '<li class="notinstalled">',$lib,'ϥ󥹥ȡ뤵Ƥޤ</li>',"\n";
		} else {
			print '<li class="installed">',$lib,'ϥ󥹥ȡ뤵Ƥޤ</li>',"\n";
		}
	}
	print '</ul>',"\n";
	print  <<'_HTML_FOOT_';
<h2>ɥХ</h2>
<ul>
	<li>ɬܥ⥸塼ǥ󥹥ȡ뤵ƤʤΤ<a href="http://nz.jugemers.net/">sbȯ</a>곰⥸塼ɡ󥹥ȡ뤷Ƥ</li>
	<li>³åǡ200 OKפɽʤ硢ᾦʸPINGȥåХåԤʤ礬ޤ(ץ꤬ɬפʤ)</li>
	<li>ץ⥸塼Image::Magickפ󥹥ȡ뤵Ƥʤ硢ͥԤޤ</li>
	<li>ץ⥸塼Net::SMTPפ󥹥ȡ뤵Ƥʤ硢᡼ΤǤʤǽޤ(sendmailѤǤвǽǤ)</li>
</ul>
</body>
</html>
_HTML_FOOT_
	return();
}
sub check_ua {
	my $flag = shift;
	if ($flag) {
		print '<ul><li>999 Skipped.</li></ul>',"\n";
		return();
	}
	eval {
		require HTTP::Request;
		require LWP::UserAgent;
		my $url = 'http://serennz.sakura.ne.jp/';
		my $ua = LWP::UserAgent->new;
		$ua->parse_head(0);
		my $request = HTTP::Request->new(GET => $url);
		my $response = $ua->request($request);
		print '<ul><li>',$response->status_line,'</li></ul>',"\n";
	};
	return();
}
